/**************************************************************
**
**         C SWING  v 3.1   31-JUL-1989 09:07:45.68
**         =========================================
**
**         Author    :  S.J.Brown
**
**         Copyright :  Public Domain
**
**         File      :  SWING_10.C
**
**         Language  :  VAXC
**
**         Compiler  :  VAX/VMS C v 2.4
**
**         VMS Ver.  :  5.1
**
***************************************************************
**
**         Change History
**         ==============
**
**         Date        Change                          Initials
**         ----------------------------------------------------
**         31-JUL-1989 Initial Version v3.0               SJB
**
**************************************************************/
 
/*
**  swing_10 spawned processes
*/
#include ctype
#include descrip
#include smgdef
#include ssdef
#include stdio
#include "swing.h"
#include "swing_refs.h"
#include "more_descrip.h"

#define BANNER "------------------------------ SWING DCL SUBPROCESS --------------------------------"
#define GIVE_ME_A_KEY 	"Press any key "
#define PROMPT       	"SWING > "

extern broadcasts_ready();

ends_in_excl(string)
char *string;
{
    int i,l;
 
    /*
    **  if string is terminated by ! plus any number of spaces return the
    **  position of the !, else return FALSE
    */
    l = strlen(string) - 1;

    for (i = l; i >= 0; i--)
    {
        if (string[i] == '!')
            return(i);
        else if (string[i] != ' ')
            return(FALSE);
    }

    /*
    **  it's just spaces, no use to man or dog, so return FALSE
    */
    return(FALSE);
}

execute_cmd(cmd,filename,terminate)
char *cmd;
char *filename;
int terminate;
{
    long length, screen;
    char indata[10];
    long col;
    int just_command, i;
    char command[SPEC_SIZE+1];

    /*
    **  check user really wants to do this
    **
    **  if the last char of command is a ! we'll not add the filename
    **  and we'll drop the !
    */

    strcpy(command,cmd);
    
    i = ends_in_excl(command);
    if (i)
    {
        just_command = TRUE;
        command[i] = 0;
        sprintf(junk,"$ %s Y/N [N] ? ",command);
    }
    else
    {
        just_command = FALSE;
        sprintf(junk,"$ %s %s Y/N [N] ? ",command,filename);
        if (strlen(junk) > 79)
        {
            sprintf(junk,"$ %s %s Y/N [N] ? ",command,"<file>");
            if (strlen(junk) > 79)
            {
                sprintf(junk,"$ %s Y/N [N] ? ",command);
                if (strlen(junk) > 79)
                {
                    sprintf(junk,"$%.70s~ Y/N [N] ? ",command);
                }
            }
        }
    }

    /*
    **  if we don't want to do this return FALSE
    */
    if (!terminate && !confirm_user(junk,"Y"))
        return(FALSE);

    /*
    **  set up display
    */
    smg$save_physical_screen(&paste,&screen);
    smg$erase_display(&display_dcl);
    smg$put_line(&display_dcl,DSC1(BANNER),&1,0);
    smg$paste_virtual_display(&display_dcl,&paste,&1,&1);

    if (just_command)
        sprintf(junk,"$ %s",command);
    else
        sprintf(junk,"$ %s %s",command,filename);

    smg$put_line(&display_dcl,DSC1(junk),&1,0);
    spawn_process(junk,0);

    /*
    **  get user to hit return to continue unless no terminate is set
    */
    if (!terminate)
    {
        col = SCREEN_WIDTH - strlen(GIVE_ME_A_KEY);
        smg$set_cursor_abs(&display_dcl,&DISPLAY_DCL_ROWS,&col);
        smg$read_string(&keyboard,
                        DSCA1(indata),
                        DSC1(GIVE_ME_A_KEY),
                        &1,0,0,0,&length,0,&display_dcl,0,0);
    }

    /*
    **  get the terminal width. if not what we set it to originally
    **  then set it back
    */
    smg$erase_display(&display_dcl);
    modify_pbd();
    smg$unpaste_virtual_display(&display_dcl, &paste);
    smg$restore_physical_screen(&paste,&screen);

    /*
    **  we ran all the way through
    */
    return(TRUE);
}

execute_dcl(filename)
char *filename;
{
    long screen,status,length,i,index,sub_index;
    char indata[10];
    int col;

    if (filename[0])
    {
        sprintf(junk,"Really execute %s Y/N [N] ? ",filename);
        if (!confirm_user(junk,"Y"))
            return(TRUE);
    }

    /*
    **  the name of the file to be executed is in filename
    */

    /*
    **  set up display
    */
    smg$save_physical_screen(&paste,&screen);
    smg$erase_display(&display_dcl);
    smg$put_line(&display_dcl,DSC1(BANNER),&1,0);

    if (!filename[0])
    {
        sprintf(junk,"Logout when finished");
        smg$put_line(&display_dcl,DSC1(junk),&2,0);
    }
    smg$paste_virtual_display(&display_dcl,&paste,&1,&1);

    if (filename[0])
    {
        /*
        **  if .exe we run it, else we @ it
        */
        if ((status = str$find_first_substring(DSC1(filename), 
                      &index,       
                      &sub_index, 
                      DSC2(".EXE;"))) == SS$_NORMAL)
        {
            sprintf(junk,"$ run %s",filename);
        }
        else if ((status = str$find_first_substring(DSC1(filename), 
                           &index,       
                           &sub_index, 
                           DSC2(".COM;"))) == SS$_NORMAL)
        {
            sprintf(junk,"$ @%s",filename);
        }
        else
        {
            sprintf(junk,"Execute %s as a command file ? Y/N [N]",filename);
        
            indata[0] = 0;
    
            /*
            **  get user to hit return to continue
            */
            smg$read_string(&keyboard,
                            DSCA2(indata),
                            DSC1(junk),
                            &1,0,0,0,&length,0,&display_dcl,0,0);
    
            if (_toupper (indata[0]) == 'Y')
            {
                sprintf(junk,"$ @%s",filename);
            }
            else
                goto way_out;
        }
    
        smg$put_line(&display_dcl,DSC1(junk),&1,0);
        spawn_process(junk,0);
        /*
        **  get user to hit return to continue
        */
        col = SCREEN_WIDTH - strlen(GIVE_ME_A_KEY);
        smg$set_cursor_abs(&display_dcl,&DISPLAY_DCL_ROWS,&col);
        smg$read_string(&keyboard,
                        DSCA1(indata),
                        DSC1(GIVE_ME_A_KEY),
                        &1,0,0,0,&length,0,&display_dcl,0,0);
    }
    else
    {
        /*
        **  now spawn a subprocess specifying DCL as the CLI
        */
        spawn_process(0,PROMPT);
    }

way_out:
    /*
    **  get the terminal width. if not what we set it to originally
    **  then set it back
    */
    smg$erase_display(&display_dcl);
    modify_pbd();
    smg$unpaste_virtual_display(&display_dcl, &paste);
    smg$restore_physical_screen(&paste,&screen);
}

disable_broadcasts()
{
    int i;

    i = smg$disable_broadcast_trapping(&paste);
    if (i != SS$_NORMAL)
        panic(i,"disable broadcast trapping","disable broadcasts");
}

enable_broadcasts()
{
    int i;

    i = smg$set_broadcast_trapping(&paste,broadcasts_ready);
    if (i != SS$_NORMAL)
        panic(i,"set broadcast trapping","enable broadcasts");
}

spawn_process(command,prompt)
char *command, *prompt;
{
    int status, mask;

    mask = CTRLT + CTRLY;
    /*
    **  now spawn a subprocess to do this command
    */
    disable_broadcasts();
    spawn_the_process(command,prompt);
    enable_broadcasts();
}

spawn_exception(sigarr, mecharr)
int *sigarr, *mecharr;
{
    /*
    **  unwind and return
    */
    lib$sig_to_ret(sigarr, mecharr);

    return(SS$_UNWIND);
}

spawn_the_process(command,prompt)
{
    int proc_id, status;
    globalref int captive;

    VAXC$ESTABLISH(spawn_exception);

    proc_id = 0;

    enable_ctrl();

    if (command)
    {
        status = LIB$SPAWN(DSC1(command), 0, 0, 0, 0,&proc_id, 
                           0, 0, 0, 0, 0);
    }
    else
    {
	if (captive)
	{
	    warning(CAPTIVE_ERRMSG);
	}
	else
	{
            status = LIB$SPAWN(0, 0, 0, 0, 0, &proc_id, 
                               0, 0, 0, 0, DSC1(prompt));
    
            if (status != SS$_NORMAL)
                warning("can't spawn a child process");
        }
    }

    disable_ctrl();

    /*
    **  slaughter child if left running
    **  check proc_id not my pid, also that it's not 0, 
    **  which is also me
    */
    if (proc_id && proc_id != getpid())
        sys$delprc(&proc_id,0);
}
